package fxHarakka;

import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import fxHarakka.luokat.Harakka;
import fxHarakka.luokat.Projekti;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.control.TabPane;
import javafx.scene.control.TextField;
import javafx.scene.input.KeyEvent;
import javafx.stage.Stage;

import java.net.URL;
import java.util.ResourceBundle;

public class LuoProjektiController implements ModalControllerInterface<Projekti>, Initializable {

    @FXML
    private Button hylkaaProjekti;

    @FXML
    private Button luoProjekti;

    @FXML
    private TextField projektiAihe;
    private String aihe = null;

    @FXML
    private TextField projektiKesto;
    private String kesto = null;
    @FXML
    private TextField projektiNimi;
    private String nimi = null;

    @FXML
    private TabPane lehti;

    //==================================================================================================



    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {

    }

    /**
     * kun painetaan hylkää projekti
     *
     *
     * @param event
     */
    @FXML
    void HylkaaProjekti(ActionEvent event) {
        projektiNimi = null;
        projektiAihe = null;
        ModalController.closeStage(projektiNimi);
    }

    /**
     *
     * @param modalityStage jos halutaan että on modaalinen vain tietylle (null ==> modaalinen kaikille)
     * @param oletus oletusprojekti joka palautetaan
     * @return Käyttämän luoma projekti
     */
    public static Projekti kysyProjekti(Stage modalityStage, Projekti oletus){

        return ModalController.showModal(HarakkaController.class.getResource("LuoProjekti.fxml"), "Lisää Projekti",
                modalityStage, oletus);

    }


    /**Jos tietokentät täytetty uusi projekti ikkunassa niin antaa modaalin kautta tiedon luodusta projektista
     * eteenpäin
     *
     *
     *
     * @param event kun painetaan luo projekti projektin luomisikkunassa
     */
    @FXML
    void luoProjekti(ActionEvent event) {
       String pNimi = projektiNimi.getText();
       String pAihe = projektiAihe.getText();
       int pKesto = 0;


       if (!projektiKesto.getText().isBlank()) {
           pKesto = Integer.parseInt(projektiKesto.getText());
       }
        if(pNimi.isBlank()){
            ModalController.closeStage(projektiAihe);
        }else {
            projektiKohdalla = new Projekti(pNimi, pAihe, pKesto);
            ModalController.closeStage(projektiAihe);
        }



    }

    @FXML
    void setAihe(KeyEvent event) {

    }

    @FXML
    void setKesto(KeyEvent event) {

    }

    @FXML
    void setNimi(KeyEvent event) {

    }

    private Projekti projektiKohdalla;

    @Override
    public Projekti getResult() {
        return projektiKohdalla;
    }

    @Override
    public void setDefault(Projekti projekti) {

    }

    @Override
    public void handleShown() {

    }


}